/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 335 (Figure A.9)
**
*/

new;
library rpb,pgraph;

cls;

proc utility_function(x,x_minus,x_plus,gamma_);
  local u,u_minus,u_plus;

  u = x^(1-gamma_);
  u_minus = x_minus^(1-gamma_);
  u_plus = x_plus^(1-gamma_);

  u = (u - u_minus) ./ (u_plus - u_minus);
  u = u .* (x .<= x_plus) + (x .> x_plus);
  u = missrv(missex(u, x .< x_minus),-10);

  retp(u);
endp;

gamma_ = 1.0001~5~20;
x = seqa(0,0.001,1500);
u = utility_function(x,0.70,1.00,gamma_);  

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|3; _plwidth = 10; _pcolor = 1|2|4; _pcross = 1;
  _pgrid = {1,1};
  ytics(-0.25,1.25,0.25,2);
  xtics(60,110,10,2);
  xlabel("\216f(t)");
  _plegstr = "\202g\201 = 1\000\202g\201 = 5\000\202g\201 = 20";
  _plegctl = {2 5 6.25 3.25};
  graphprt("-c=2 -cf=app1-3-3-5.eps");
  xy(100*x,u);
