/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 341 (Exercise B.1.4)
**
*/

new;
library rpb,pgraph;

rndseed 123456;

__output = 0;

cls;

print;
print "=====================  Question 1.d  =======================================";

let beta_ = 0.7  0.9  1.1 1.3  1.5;
let w1   = 0.5  0.5  0.0 0.0  0.0;
let w2   = 0.25 0.25 0.5 0.5 -0.5;

beta1 = w1'beta_;
beta2 = w2'beta_;
print ftos(beta1,"beta1 = %lf",3,3);
print ftos(beta2,"beta2 = %lf",3,3);

print;
print "=====================  Question 2.c =======================================";


let sigma = 0.05 0.06 0.80;
rho = -0.49;
rho = diagrv(rho*ones(3,3),1.0);
call invpd(rho);
cov = rho .* sigma' .* sigma;
b = ones(3,1)/3;
beta_ = (cov*b)/(b'*cov*b);

print ftosa(sigma~beta_,"%lf",3,3);

print;
print "=====================  Question 2.d =======================================";

let sigma = 0.15 0.20 0.22;
let rho = 1.0
          0.7  1.0
          0.2 -0.5 1.0;
rho = xpnd(rho);
call invpd(rho);
cov = rho .* sigma' .* sigma;
b = ones(3,1)/3;
beta_ = (cov*b)/(b'*cov*b);
print ftosa(sigma~beta_,"%lf",3,3);

print;
print "=====================  Question 2.e =======================================";

let b = 0.05 0.25 0.70;
beta1 = (cov*b)/(b'*cov*b);
let b = 0.20 0.40 0.40;
beta2 = (cov*b)/(b'*cov*b);
print ftosa(sumc(beta1),"sum of beta_ (1) = %lf",3,3);
print ftosa(sumc(beta2),"sum of beta_ (2) = %lf",3,3);

print;
print "=====================  Question 4.b =======================================";

let sigma = 0.20 0.20 0.20;
let rho = 1.0
          0.5  1.0
          0.0 -0.5 1.0;
rho = xpnd(rho);
call invpd(rho);
Sigma = sigma .* sigma' .* rho;

let x = 0.50 0.45 0.05;

beta_ = (Sigma*x) / (x'Sigma*x);
print ftosa(beta_,"%lf",3,2); 

print;
print "=====================  Question 5.a =======================================";


let R_b =  -0.26            -0.09            -0.10            -0.10             0.16             0.14 
            0.14             0.15            -0.22            -0.07            -0.11             0.02 
            0.15            -0.15            -0.01            -0.23             0.15            -0.06; 

let R_i =  -0.22            -0.11            -0.10            -0.08             0.13             0.11 
            0.21             0.13            -0.30            -0.06            -0.05            -0.05 
            0.19            -0.17             0.02            -0.24             0.25            -0.07; 

y = R_i;
x = R_b;
beta_hat = y/x;
u = y - x*beta_hat;
std_y = stdc(y);
std_x = stdc(x);
std_u = stdc(u);

print ftos(beta_hat,"beta(i) = %lf",3,5);
print ftos(std_y^2,"var(i) = %lf",3,5);
print ftos(std_x^2,"var(b) = %lf",3,5);
print ftos(beta_hat^2*std_x^2+std_u^2,"var(i) = %lf",3,5);
print ftos(100*(beta_hat^2)*(std_x^2)/(std_y^2),"ctr(b) = %lf",3,2)$+"%";

