/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 344 (Exercise B.1.7)
**
*/

new;
library rpb,pgraph;

__output = 0;

cls;

let mu = 0.10 -0.10 0.00 0.05;
let sigma = 0.15 0.20 0.25 0.30;
let rho =   1.0
            0.5 1.0
            0.4 0.3 1.0
            0.1 0.1 0.1 1.0;

rho = xpnd(rho);
cov = rho .* sigma .* sigma';
nAssets = rows(cov);

print;
print "=====================  Question 1  =======================================";

{x,vol,mr,rc,prc} = Compute_ERC_Portfolio(0,cov);
results_erc = 100*(x~mr~rc~prc);

print ftosa(results_erc,"%lf",3,2);

print;
print "=====================  Question 2  =======================================";

x0 = x;
sigma_x0 = sqrt(x0'*cov*x0);
A = ones(1,nAssets); B = 1;
Bounds = ones(nAssets,1) .* (0~1);

Results_te = 100*x0|error(0)|error(0)|error(0)|100*sigma_x0|error(0);

// Question 2.a

{x,alpha,te,gamma_x,retcode} = Compute_TE_Portfolio(x0,mu,cov,A,B,0,0,Bounds,0.01,2);
IR = alpha/te;
sigma_x = sqrt(x'*cov*x);
rho = (x'*cov*x0)/(sigma_x * sigma_x0);
Results_te = Results_te ~ (100*x|100*(alpha|te)|IR|100*(sigma_x|rho));

// Question 2.b

{x,alpha,te,gamma_x,retcode} = Compute_TE_Portfolio(x0,mu,cov,A,B,0,0,Bounds,0.05,2);
IR = alpha/te;
sigma_x = sqrt(x'*cov*x);
rho = (x'*cov*x0)/(sigma_x * sigma_x0);
Results_te = Results_te ~ (100*x|100*(alpha|te)|IR|100*(sigma_x|rho));

{x,alpha,te,gamma_x,retcode} = Compute_TE_Portfolio(x0,mu,cov,A,B,0,0,Bounds,0.10,2);
IR = alpha/te;
sigma_x = sqrt(x'*cov*x);
rho = (x'*cov*x0)/(sigma_x * sigma_x0);
Results_te = Results_te ~ (100*x|100*(alpha|te)|IR|100*(sigma_x|rho));

// Question 2.c

{x,alpha,te,gamma_x,retcode} = Compute_TE_Maximum(x0,mu,cov,A,B,0,0,Bounds);
IR = alpha/te;
sigma_x = sqrt(x'*cov*x);
rho = (x'*cov*x0)/(sigma_x * sigma_x0);
Results_te = Results_te ~ (100*x|100*(alpha|te)|IR|100*(sigma_x|rho));

print ftosa(results_te,"%lf",3,2);

gamma_1 = seqa(-2,2/50,500);
{x1,mu_te1,vol_te1,gamma1,retcode} = Compute_TE_Portfolio(x0,mu,cov,A,B,0,0,Bounds,gamma_1,0);

Results_te = 100*x0|error(0)|error(0)|error(0)|100*sigma_x0|error(0);

print;
print "=====================  Question 3  =======================================";

Bounds = ones(nAssets,1) .* (-5~5);

// Question 3.a
{x,alpha,te,gamma_x,retcode} = Compute_TE_Portfolio(x0,mu,cov,A,B,0,0,Bounds,0.01,2);
IR = alpha/te;
sigma_x = sqrt(x'*cov*x);
rho = (x'*cov*x0)/(sigma_x * sigma_x0);
Results_te = Results_te ~ (100*x|100*(alpha|te)|IR|100*(sigma_x|rho));

dx1 = x - x0;

// Question 3.b
{x,alpha,te,gamma_x,retcode} = Compute_TE_Portfolio(x0,mu,cov,A,B,0,0,Bounds,0.05,2);
IR = alpha/te;
sigma_x = sqrt(x'*cov*x);
rho = (x'*cov*x0)/(sigma_x * sigma_x0);
Results_te = Results_te ~ (100*x|100*(alpha|te)|IR|100*(sigma_x|rho));

dx2 = x - x0;

{x,alpha,te,gamma_x,retcode} = Compute_TE_Portfolio(x0,mu,cov,A,B,0,0,Bounds,0.10,2);
IR = alpha/te;
sigma_x = sqrt(x'*cov*x);
rho = (x'*cov*x0)/(sigma_x * sigma_x0);
Results_te = Results_te ~ (100*x|100*(alpha|te)|IR|100*(sigma_x|rho));

dx3 = x - x0;

// Question 3.c
{x,alpha,te,gamma_x,retcode} = Compute_TE_Portfolio(x0,mu,cov,A,B,0,0,Bounds,0.35,2);
IR = alpha/te;
sigma_x = sqrt(x'*cov*x);
rho = (x'*cov*x0)/(sigma_x * sigma_x0);
Results_te = Results_te ~ (100*x|100*(alpha|te)|IR|100*(sigma_x|rho));

dx4 = x - x0;

print ftosa(results_te,"%lf",3,2);

gamma_2 = seqa(-2,2/20,500);
{x2,mu_te2,vol_te2,gamma2,retcode} = Compute_TE_Portfolio(x0,mu,cov,A,B,0,0,Bounds,gamma_2,0);

print ftosa((dx2./dx1)~(dx3./dx1)~(dx4./dx1),"%lf",3,2);

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1; _pcross = 1; _plwidth = 10; _pcolor = 1|2|4;
  ylabel("\216\202m\201(x | b) (in %)");
  xlabel("\216\202s\201(x | b) (in %)");
  ytics(-20,20,10,2);
  xtics(0,20,5,2);
  _plegstr = "Constrained\000Unconstrained";
  _plegctl = {2 5 1.5 0.75}; 
  graphprt("-c=2 -cf=app2-1-7-1.eps");
  xy(100*(vol_te1~vol_te2),100*(mu_te1~mu_te2));
