/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 331 (Exercise B.2.3)
**
*/

new;
library rpb,pgraph;

cls;

let sigma = 0.15 0.20 0.25;
let rho =   1.0
            0.5 1.0
            0.4 0.3 1.0;

rho = xpnd(rho);
cov = rho .* sigma .* sigma';

print;
print "=====================  Question 1.e  =======================================";

{x,vol,mr,rc,prc} = Compute_ERC_Portfolio(0,cov);
results_erc = 100*(x~mr~rc~prc);

print ftosa(results_erc,"%lf",3,2);

x = ones(3,1)/3;

Results = {};

iter = 1;
do until iter > 15;
  _beta = (cov*x)/(x'cov*x);

  Results = Results ~ (100*x|_beta);
  
  x = 1./_beta;
  x = x / sumc(x);

  iter = iter + 1;
endo;

print ftosa(Results[.,1:6],"%lf",3,4);
print ftosa(Results[.,7:12],"%lf",3,4);

print;
print "=====================  Question 2.b  =======================================";

n = 10;
_beta = rndu(1,1) * ones(n,1);
omega = 0.20;
sigma = rndu(n,1)*0.10;
cov = _beta*_beta'*(omega^2) + diagrv(zeros(n,n),sigma^2);
{x,vol,mr,rc,prc} = Compute_ERC_Portfolio(0,cov);
indx = sortind(x);

test = sigma[indx];
test = test .<= lag1(test);
test[1] = 1;

Results = 100*submat((x~sigma),indx,0)~test;

print ftosa(Results,"%lf",3,2);

print;
print "=====================  Question 2.c.i  =======================================";

n = 10;
_beta = rndu(n,1);
omega = 0.20;
sigma = rndu(1,1)*ones(n,1);
cov = _beta*_beta'*(omega^2) + diagrv(zeros(n,n),sigma^2);
{x,vol,mr,rc,prc} = Compute_ERC_Portfolio(0,cov);
indx = sortind(x);

test = _beta[indx];
test = test .<= lag1(test);
test[1] = 1;

Results = submat((100*x~_beta),indx,0)~test;

print ftosa(Results,"%lf",3,2);

print;
print "=====================  Question 2.c.ii  =======================================";

n = 5000;
_beta = rndu(n,1);
omega = 0.20;
sigma = 0.05*ones(n,1);
cov = _beta*_beta'*(omega^2) + diagrv(zeros(n,n),sigma^2);
// {x1,vol,mr,rc,prc} = Compute_ERC_Portfolio(0,cov);
x = 1 ./ _beta;
x = x / sumc(x);

prc = x .* (cov*x);
prc = prc / sumc(prc);

graphset;
  _pframe = 0; _pdate = ""; _pnum = 2;
  _pltype = 6; _pcolor = 1; _plwidth = 10;
  ytics(0.0,2.0,0.5,2);
  xy(0,n*prc);

print;
print "=====================  Question 2.d  =======================================";

n = 4;
let _beta = 1 0.9 0.8 .7;
omega = 0.20;
let sigma = 0.05 0.05 0.10 0.10;
cov = _beta*_beta'*(omega^2) + diagrv(zeros(n,n),sigma^2);
{x,vol,mr,rc,prc} = Compute_ERC_Portfolio(0,cov);
results_erc = 100*(x~mr~rc~prc);

print ftosa(results_erc,"%lf",3,2);

