/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 371 (Exercise B.3.8)
**
*/

new;
library rpb,pgraph;

cls;

PathName = "data\\";
datFileName = PathName $+ "msci-wgbi-djubs-fed"; 
data = loadd(datFileName);
vnames = "" $+ getname(datFileName);

Begin_Date = 19981231;
End_Date = 20111230;

data = selif(data,(data[.,1] .>= Begin_Date) .and (data[.,1] .<= End_Date));
data = Fill_Miss(data,4);

Dates = data[.,1];
nDates = rows(Dates);

Months = trunc(Dates/100);
RD_Monthly = Months ./= lag1(Months);
RD_Monthly[1] = 1;
RD_Weekly = zeros(nDates,1);
RD_Weekly[seqa(1,5,nDates/5)] = ones(nDates/5,1);
RD = RD_Weekly;

Basket = Data[.,2 3 4];
Basket = 100 * Basket ./ Basket[1,.];
R_Basket = Basket./lag1(Basket) - 1.0;
nAssets = cols(Basket);
Libor = Data[.,5]/100;

let study_dates = 19991231 20021231 20051231 20071231 20081231 20101231;
nLags = 260;

i = 1;
do until i > rows(Study_Dates);
  indx = closest_index(study_Dates[i],Dates);
  Study_Dates[i] = Dates[indx];
  Rt = R_Basket[indx-nLags:indx,.];
  sigma = sqrt(260) * stdc(Rt);
  rho = corrx(Rt);
  print "----------------------------------------";
  print ftosa(Study_Dates[i],"%lf",3,0);
  print ftosa(100*sigma',"%lf",3,2);
  print ftosa(100*rho,"%lf",3,2);
  i = i + 1;
endo;


