/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 72 (Figure 2.1)
**
*/

new;
library rpb,pgraph;

let w = 0.70 0.30;
data = w .* (1~0.20~0.10);

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pbarwid = 0.5; _pbartyp = {5 1, 6 2};
  xtics(0,4,1,1);
  ytics(0,100,10,2);
  let xlab = "\216WB" "RB" "PB";
  asclabel(xlab,0);
  _plegstr = "Asset 1\000Asset 2";
  _plegctl = {2 5 6 5};
  _pmsgstr = "100%\00020%\00010%\000Weights\000Risk\000Return";
  _pmsgctl = {0.9 101  .12 0 1 0 7,
              1.9 21.5 .12 0 1 0 7,
              2.9 11.5 .12 0 1 0 7,
              0.69 45 .18 90 1 0 7,
              1.69 5  .18 90 1 0 7,
              2.69 1  .18 90 1 0 7};
  graphprt("-c=2 -cf=chap2-0-0-1.eps");
  bar(0,100*rev(cumsumc(data))');
