/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 111 (Uniqueness problem)
**
*/

new;
library rpb,pgraph;

cls;

let sigma = 0.25 0.20 0.20;
let rho =   1.00
            0.50   1.00
           -0.50  -0.50  1.00;
rho = xpnd(rho);
cov = rho .* sigma .* sigma';
call invpd(cov);

let b = 0.51 0.51 -0.02;

{x,vol,mr,tr,rc} = Compute_RB_Portfolio(0,cov,b);
result1 = 100*(x~mr~tr~rc);

print ftosa(result1,"%lf",3,2);

let b = 0.50 0.50 0.00;
let x = 0.60 0.60 0.00;
eps = seqa(-1.00,2.00/100,101);

neps = rows(eps);
vol_results = miss(zeros(neps,2),0);
rc_results = miss(zeros(neps,2),0);
j = 1;
do until j > neps;
  x[3] = eps[j]; 
  vol_results[j,1] = sqrt(x'cov*x);
  {vol,mr,rc,prc} = Compute_Risk_Contribution(x,cov);
  rc_results[j,1] = rc[3];
  j = j + 1;
endo;

graphset;
  fonts("simplex simgrma");
  _pdate = ""; _pnum = 2; _pframe = 0; _pcross = 1;
  _pltype = 6|3; _pcolor = 1|4; _plwidth = 10;
  xtics(-100,100,50,2);
  ytics(-4,16,4,2);
  xlabel("\216x]3[ (in %)");
  ylabel("\216\202s\201(x) (in %)");
  graphprt("-c=2 -cf=chap2-2-2-6.eps");
  xy(100*eps,100*rc_results);





