/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 178 (Example 31)
**
*/

new;
library rpb,pgraph;

cls;

rhoTable = zeros(4,2);

iter = 1;

start:

if iter == 1;
  rho_1 = 0.70;
  rho_2 = 0.20;
elseif iter == 2;
  rho_1 = 0.70;
  rho_2 = -0.50;
elseif iter == 3;
  rho_1 = 0.90;
  rho_2 = 0.85;
elseif iter == 4;
  rho_1 = 0.20;
  rho_2 = 0.15;
endif;

__output = 0;
nIters = 50;
weights = miss(zeros(nIters,4),0);

n = 4;
do until n > nIters;
  sigma = 0.20 * ones(n,1);

  rho = diagrv(rho_1*ones(n,n),1);
  rho[1:n-2,n-1|n] = zeros(n-2,2);
  rho[n-1|n,1:n-2] = zeros(2,n-2);
  rho[n,n-1] = rho_2;
  rho[n-1,n] = rho_2;

  call invpd(rho);

  cov = sigma .* sigma' .* rho;

  i = 1;
  do until i > 4;
    x = ones(n,1)/n;
    if i == 4;
     {vol,mr,rc,prc} = Compute_Risk_Contribution(x,cov);
    elseif i == 1;
      {x,vol,retcode} = Compute_MV_Portfolio(cov,ones(1,n),1,0,0,ones(n,1).*(0~1));
      {vol,mr,rc,prc} = Compute_Risk_Contribution(x,cov);
    elseif i == 2;
      {x,vol,mr,rc,prc} = Compute_ERC_Portfolio(x,cov);
    elseif i == 3;
//      {x,vol,mr,rc,prc} = Compute_MDP_Portfolio(x,cov,0);
    endif;
  
    weights[n,i] = 1-sumc(x[1:n-2]);

    i = i + 1;
  endo;

  n = n + 1;
endo;

rhoTable[iter,.] = rho_1~rho_2;
call varput(weights,itos_rpb("weight",iter));

if iter < 4;
  iter = iter + 1;
  goto start;
endif;

cls;

graphset;
  begwind;
  window(2,2,0);

  fonts("simplex simgrma");
  _pdate = ""; _pframe = 0; _pnum = 2;
  _pltype = 6|1|3; _pcolor = 1|2|4; _plwidth = 10;
  _pnumht = 0.22; _paxht = 0.25; _ptitlht = 0.275;
  ytics(0,80,20,2);
  xtics(0,50,10,2);
  xlabel("\216n");

  iter = 1;
  do until iter > 4;
    Weights = varget(itos_rpb("weight",iter));

    setwind(iter);
     str = ftos(100*rhoTable[iter,1],"\202r\201 = %lf",1,0) $+ "% - " $+
           ftos(100*rhoTable[iter,2],"\202r\201]1,2[ = %lf",1,0) $+ "%";
     title("\216" $+ str);
     if iter == 4;
       _plegstr = "MV/MDP\000ERC\000EW";
       _plegctl = {2 6 5 3.5};
     endif;

      xy(0,100*Weights[.,1 2 4]);
      print ftosa(100*Weights[4 50,.],"%lf",3,2);

   iter = iter + 1;
  endo;

  graphprt("-c=2 -cf=chap3-2-3-10.eps");

  endwind;
