/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 179 (Example 32)
**
*/

new;
library rpb,pgraph;

cls;

rndseed 123456;

n = 50;

beta_ = 4*rndu(n,1) - 1.0;
sigma_tilde = 0.05 * ones(n,1);
sigma_m = 0.25;
sigma_m_sqr = sigma_m^2;
D = diagrv(zeros(n,n),sigma_tilde^2);

cov = sigma_m_sqr * beta_ * beta_' + D;

bounds = (0~1) .* ones(n,1);

x_ew = ones(n,1)/n;
{x_mv,vol,retcode} = Compute_MV_Portfolio(cov,ones(1,n),1,0,0,bounds);
_rpb_CCD_maxiters = 10000;
{x_erc,vol,mr,rc,prc} = Compute_ERC_Portfolio(x_ew,cov);
{x_mdp,vol,mr,rc,prc} = Compute_MDP_Portfolio(x_ew,cov,bounds);

graphset;
  begwind;
  window(2,2,0);

  fonts("simplex simgrma");
  _pdate = ""; _pframe = 0; _pnum = 2;
  _pltype = 6|1|3; _pcolor = 1|2|4; _plwidth = 10;
  _pstype = 11; _plctrl = -1; _psymsiz = 5.0;
  _pnumht = 0.20; _paxht = 0.25; _ptitlht = 0.275;
  xtics(-1,3,1,2);
  ytics(0,8,2,2);
  xlabel("\216\202b\201]i[");

  setwind(1);
    title("\216EW");
    _pcolor = 1;
    xy(beta_,100*x_ew);

  setwind(2);
    title("\216MV");
    _pcolor = 2;
    xy(beta_,100*x_mv);

  setwind(3);
    title("\216MDP");
    _pcolor = 3;
    xy(beta_,100*x_mdp);

  setwind(4);
    title("\216ERC");
    _pcolor = 4;
    xy(beta_,100*x_erc);

    graphprt("-c=2 -cf=chap3-2-3-11.eps");

  endwind;
