/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 239 (Figure 4.20)
**
*/

new;
library rpb,pgraph;

cls;

FileName = "Results\\sovereign-bonds-egbi.fmt";
loadm egbi = ^FileName;

FileName = "Results\\sovereign-bonds-rb-egbi.fmt";
loadm egbi_rb = ^FileName;

FileName = "Results\\sovereign-bonds-debt.fmt";
loadm debt = ^FileName;

FileName = "Results\\sovereign-bonds-rb-debt.fmt";
loadm debt_rb = ^FileName;

FileName = "Results\\sovereign-bonds-gdp.fmt";
loadm gdp = ^FileName;

FileName = "Results\\sovereign-bonds-rb-gdp.fmt";
loadm gdp_rb = ^FileName;

nCountries = 11;
indx_dates = 1;
indx_x = seqa(2,1,nCountries);
indx_rc = seqa(nCountries+2,1,nCountries);
indx_vol = 2*nCountries+2;

if (egbi[.,1] == egbi_rb[.,1]) and (debt[.,1] == gdp[.,1]) and (gdp_rb[.,1] == debt_rb[.,1]) and (gdp_rb[.,1] == debt[.,1]);
  Dates = debt[.,1];
  nDates = rows(Dates);
else;
  errorlog "error";
  end;
endif;

indx = indx_vol;
data = debt[.,indx]~gdp[.,indx]~debt_rb[.,indx]~gdp_rb[.,indx]~egbi[.,indx];
indx = maxindc(data);
print subvec(data',indx)~dates[indx];

data[.,5] = missex(data[.,5], Dates .<= 20100701);
t = seqa(1,1,ndates);
t = seqa(-60,1,60)|t;
data = miss(zeros(60,5),0) | data;

step = 5.1;
if step == 1;
  indx = seqa(1,1,rows(t));
else;
  indx = seqa(1,step,rows(t)/step)|rows(t);
endif;

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0; _pgrid = {1,1};
  _pltype = 6|3|6|3|1; _plwidth = 10; _pcolor = 1|2|3|4|7; _plctrl = 0|0|131|131; _pstype = 8;  
  _plctrl = _plctrl/step;
  let xlab = "2008" "" "2009" "" "2010" "" "2011" "" "2012" "";
  asclabel(xlab,0);
  xtics(1,nDates,131,0);
  ytics(0,14,2,2);
  _plegstr = "DEBT-WB\000GDP-WB\000DEBT-RB\000GDP-RB";
  _plegctl = {2 5 1.5 5.0};
  graphprt("-c=2 -cf=chap4-3-2-17.eps");
  xy(t[indx],100*data[indx,1:4]);
