/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 278 (Figure 6.6)
**
*/

new;
library rpb,pgraph;

cls;

x = seqa(0,0.01,101);
n = rows(x);
SR = 0.25;

let sigma1[1,4] = 0.20 0.20  0.20  0.20; 
let sigma2[1,4] = 0.05 0.05  0.05  0.20; 
let rho[1,4]    = 0.70 0.00 -0.40  -0.50;

{pi1,pi2} = Implied_Risk_Premium2(x,sigma1,sigma2,rho,SR);

graphset;
  window3d;
  fonts("simplex simgrma");

  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1; _plwidth = 10; _pcolor = 1|2;
  _pnumht = 0.20; _paxht = 0.250; _ptitlht = 0.25;

  xlabel("\216x]1[ (in %)");
  xtics(0,100,20,2);
  ytics(0,5,1,0);

  i = 1;
  setwind(i);  
    title("\216\202r\201 = 70%");
    xy(100*x,100*(pi1[.,i]~pi2[.,i]));

  i = 2;
  setwind(i);  
    title("\216\202r\201 = 0");
    xy(100*x,100*(pi1[.,i]~pi2[.,i]));

  _pcross = 1;
  i = 3;
  setwind(i); 
    title("\216\202r\201 = -40%");
    ytics(-2,5,1,0);
    _plegstr = "Asset 1\000Asset 2";
    _plegctl = {2 6 7 4};
    xy(100*x,100*(pi1[.,i]~pi2[.,i]));

    graphprt("-c=2 -cf=chap6-1-2-4.eps");

  endwind;
