/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 286 (Figure 6.10)
**
*/

new;
library rpb,pgraph;

cls;

let w[4,16] = 9.8    8.5     1.0     3.5     0.0     3.3     8.8    10.9     6.4     3.6     3.9     5.8    18.5     4.1     8.8     3.7
             54.9   42.3    57.7    37.5    76.0    40.8    50.7    26.1    49.0    46.5    58.9    56.2    59.2    61.3    40.8    27.1
             26.8   32.8    13.9    40.6    22.0     6.1    21.8    52.3    11.1    32.2    30.9    22.2    12.1    25.5    21.5    45.8
              8.5   16.4    27.5    18.4     2.0    49.9    18.8    10.8    33.5    17.6     6.4    15.7    10.2     9.0    28.9    23.4;

Let string country = "Austria" "Belgium" "Denmark" "Finland" "France" "Germany" "Iceland" "Ireland" "Italy" "Nether." "Norway" 
                    "Portugal" "Spain" "Sweden" "Switz." "UK";
let indx = 5 6 9 11 13 14 16;

ratio = sumc(w[1 2,.])./sumc(w);
call dstat(0,ratio);

w = 100 * w ./ sumc(w)';
w = w';

graphset;
  begwind;
  window(2,2,0);

  _pdate = ""; _pnum = 2; _pframe = 0;
  _paxht = 0.20; _pnumht = 0.153; _ptitlht = 0.25;
  _pbarwid = 0.50;
  xlab = 0 $+ country[indx];
  asclabel(xlab,0);

  _pbartyp = {4 1};
  setwind(1);
    title("\216Equities");
    ytics(0,50,10,2);
    bar(0,w[indx,3]);

  _pbartyp = {2 2};  
  setwind(2);
    title("\216Bonds");
    ytics(0,80,20,2);
    bar(0,w[indx,2]);

  _pbartyp = {3 3};
  setwind(3);
    title("\216Cash");
    ytics(0,20,5,2);
    bar(0,w[indx,1]);

  _pbartyp = {1 4};
  setwind(4);
    title("\216Others");
    ytics(0,50,10,2);
    bar(0,w[indx,4]);

    graphprt("-c=2 -cf=chap6-2-1-1.eps");
  endwind;
